#!/usr/bin/env python
import numpy as np
from sklearn.decomposition import IncrementalPCA
from joblib import Parallel, delayed
import sys
from importlib import reload
reload(sys)
#sys.setdefaultencoding("utf-8")

INPUT = sys.argv[1]
N = int(sys.argv[2])
CHUNK_SIZE = int(sys.argv[3])
OUT = "output.vectors.w2v"

ipca = IncrementalPCA(n_components=N, batch_size=20)

uris = []
with open(INPUT) as f:
    next(f)
    for line in f:
        line = line[:-1].split(' ')
        uris.append(line[0])

def get_chunk(a, b):
    X = []
    with open(INPUT) as f:
        next(f)
        for i, line in enumerate(f):
            if i >= a and i < b:
                line = line[:-1].split(' ')
                try:
                    X.append([float(l) for l in line[1:-1]])
                except ValueError:
                    print("'{}'".format(line))
            if i >= b:
                break
    return X

Y = None
m = len(uris) // CHUNK_SIZE + 1
for i in range(0, m):
    # pX = X[i*CHUNK_SIZE : (i+1)*CHUNK_SIZE]
    pX = get_chunk(i*CHUNK_SIZE, (i+1)*CHUNK_SIZE)
    ipca.partial_fit(pX)
    print("Partial fit: {:.2f}% done".format(100*float(i+1)/m))
    sys.stdout.flush()
for i in range(0, m):
    # pX = X[i*CHUNK_SIZE : (i+1)*CHUNK_SIZE]
    pX = get_chunk(i*CHUNK_SIZE, (i+1)*CHUNK_SIZE)
    Y2 = np.array(ipca.transform(pX))
    if Y is None:
        Y = Y2
    else:
        Y = np.vstack((Y, Y2))
    print("Transform: {:.2f}% done".format(100*float(i+1)/m))
    sys.stdout.flush()

rows = 0
with open(OUT + ".tmp", "w") as f:
    for y, u in zip(Y, uris):
       # if u.startswith('dbr_'):
         if True:
            f.write("{} {}\n".format(u," ".join([str(yi) for yi in y])))
            rows += 1

# prepend information to file
with open(OUT, "w") as f:
    f.write("{} {}\n".format(rows, N))
    with open(OUT + ".tmp") as ftmp:
        for line in ftmp:
            f.write(line)

import os
os.remove(OUT + ".tmp")

